﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Collections;
using System.Security.Cryptography;
using System.Data.SqlClient;
using System.Data;
using System.Runtime.InteropServices;
using minsouk.WorkGenerator;

namespace minsouk.WorkGenerator
{
    class CConfig
    {
        public string ConnectionString
        {
            get
            {
                return "Data Source=1.1.1.1,1433;Initial Catalog=config;" // ncloud server 
                     + "User ID=minsouk;Password=P@ssw0rd;";
            }
        }

        public string TargetConnectionString 
        {
            get { return tConfigCopyReadValue("COMM", "targetDatabase"); } 
        }



        public string TargetCWORK1workThreadCnt 
        {
            get { return tConfigCopyReadValue("CWORK1", "workThreadCnt"); } // copy 한 값을 현재값으로 서비스한다. 
            set { tConfigWriteValue("CWORK1", "workThreadCnt", value); }  // 현재값을 다른값으로 업데이트 한다. 
        }
        public string TargetCWORK1sleepMiliSec 
        {
            get { return tConfigCopyReadValue("CWORK1", "sleepMiliSec"); }
            set { tConfigWriteValue("CWORK1", "sleepMiliSec", value); }
        }
        public string TargetCWORK2workThreadCnt 
        {
            get { return tConfigCopyReadValue("CWORK2", "workThreadCnt"); }
            set { tConfigWriteValue("CWORK2", "workThreadCnt", value); }
        }
        public string TargetCWORK2sleepMiliSec 
        {
            get { return tConfigCopyReadValue("CWORK2", "sleepMiliSec"); }
            set { tConfigWriteValue("CWORK2", "sleepMiliSec", value); }
        }
        public string TargetCWORK2loopCnt
        {
            get { return tConfigCopyReadValue("CWORK2", "loopCnt"); }
            set { tConfigWriteValue("CWORK2", "loopCnt", value); }
        }
        public string TargetCWORK3workThreadCnt 
        {
            get { return tConfigCopyReadValue("CWORK3", "workThreadCnt"); }
            set { tConfigWriteValue("CWORK3", "workThreadCnt", value); }
        }
        public string TargetCWORK3sleepMiliSec 
        {
            get { return tConfigCopyReadValue("CWORK3", "sleepMiliSec"); }
            set { tConfigWriteValue("CWORK3", "sleepMiliSec", value); }
        }



        public string TargetNewCWORK1workThreadCnt 
        { 
            get { return tConfigReadValue("CWORK1", "workThreadCnt"); }  // 새로 읽은값을 리턴함
        }
        public string TargetNewCWORK1sleepMiliSec
        {
            get { return tConfigReadValue("CWORK1", "sleepMiliSec"); }
        }

        public string TargetNewCWORK2workThreadCnt 
        {
            get { return tConfigReadValue("CWORK2", "workThreadCnt"); }
        }
        public string TargetNewCWORK2sleepMiliSec 
        {
            get { return tConfigReadValue("CWORK2", "sleepMiliSec"); }
        }
        public string TargetNewCWORK2loopCnt
        {
            get { return tConfigReadValue("CWORK2", "loopCnt"); }
        }
        public string TargetNewCWORK3workThreadCnt
        {
            get { return tConfigReadValue("CWORK3", "workThreadCnt"); }
        }
        public string TargetNewCWORK3sleepMiliSec
        {
            get { return tConfigReadValue("CWORK3", "sleepMiliSec"); }
        }

        public List<WorkTypeCnt> GetWorkTypeCnt
        {
            get
            {
                var query =
                    from a in tConfigCopy
                    where a.cKey == "workThreadCnt"
                    select new WorkTypeCnt { workType = a.workType, cValue = a.cValue };
                List<WorkTypeCnt> list = query.ToList<WorkTypeCnt>();
                return list;
            }
        }

        public static CConfig Config { get; set; } // 내부에서 생성된 객체를 억세스 가능하게 해줌
        List<TConfig> tConfig { get; set; }
        List<TConfig> tConfigCopy { get; set; }

        private string tConfigReadValue(string workType, string cKey)
        {
            var query =
                (from a in tConfig
                 where a.workType == workType && a.cKey == cKey
                 select new { cValue = a.cValue }).Single();
            return query.cValue.ToString();
        }

        private string tConfigCopyReadValue(string workType, string cKey)
        {
            var query =
                (from a in tConfigCopy
                 where a.workType == workType && a.cKey == cKey
                 select new { cValue = a.cValue }).Single();
            return query.cValue.ToString();
        }

        private void tConfigWriteValue(string workType, string cKey, string updateValue)
        {
            foreach (var a in tConfigCopy) // 현재값에 업데이트 해줌 
            {
                if (a.workType == workType && a.cKey == cKey)
                {
                    a.cValue = updateValue;
                }
            }
        }

        static CConfig()
        {
            Config = new CConfig(); // singleton
        }
        private CConfig() { } // 외부에서 생성을 막음
        
        // config 번호를 입력인자로 받는다. 
        public int configIdx { get; set; }

        public void LoadConfiguration(string[] args)
        {
            ArrayList inputParameters = new ArrayList();
            foreach (var a in args)
            {
                inputParameters.Add(a.ToUpper());
            }

            if (inputParameters.Count == 0)  // 입력 변수가 없으면
            {
                Console.WriteLine("instruction (just type configIdx Ex: programName.exe -c 1)");
                Console.ReadKey();
                Environment.Exit(0);
            }

            // config 번호를 셋팅 
            this.configIdx = Convert.ToInt32(inputParameters[inputParameters.IndexOf("-C") + 1]); // 행의 길이

            // 데이터베이스에서 설정값 읽기
            CDatabase cDatabase = new CDatabase(ConnectionString);
            tConfig = cDatabase.uspGetTConfig(configIdx);
            tConfigCopy = tConfig; // 현재값을 셋팅해준다. 
        }
                
        // 쿼리해서 변경된 값이 있는지 찾고 업데이트 한다. 
        public void ChangeDBConfigCheck(int configIdx, CThreadManager cThreadManager)
        {
            ChangeDBConfigEvent += cThreadManager.OnEventAction;
            while (true)
            {
                CDatabase cDatabase = new CDatabase(ConnectionString);
                tConfig = cDatabase.uspGetTConfig(configIdx);



                if (TargetCWORK1workThreadCnt != TargetNewCWORK1workThreadCnt)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK1workThreadCnt, TargetNewCWORK1workThreadCnt);
                    ChangeDBConfigLoop(Convert.ToInt32(TargetNewCWORK1workThreadCnt), Convert.ToInt32(TargetCWORK1workThreadCnt), "CWORK1");
                    TargetCWORK1workThreadCnt = TargetNewCWORK1workThreadCnt;
                }
                if (TargetCWORK2workThreadCnt != TargetNewCWORK2workThreadCnt)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK2workThreadCnt, TargetNewCWORK2workThreadCnt);
                    ChangeDBConfigLoop(Convert.ToInt32(TargetNewCWORK2workThreadCnt), Convert.ToInt32(TargetCWORK2workThreadCnt), "CWORK2");
                    TargetCWORK2workThreadCnt = TargetNewCWORK2workThreadCnt;
                }
                if (TargetCWORK3workThreadCnt != TargetNewCWORK3workThreadCnt)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK3workThreadCnt, TargetNewCWORK3workThreadCnt);
                    ChangeDBConfigLoop(Convert.ToInt32(TargetNewCWORK3workThreadCnt), Convert.ToInt32(TargetCWORK3workThreadCnt), "CWORK3");
                    TargetCWORK3workThreadCnt = TargetNewCWORK3workThreadCnt;
                }
                if (TargetCWORK1sleepMiliSec != TargetNewCWORK1sleepMiliSec)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK1sleepMiliSec, TargetNewCWORK1sleepMiliSec);
                    TargetCWORK1sleepMiliSec = TargetNewCWORK1sleepMiliSec;
                }
                if (TargetCWORK2sleepMiliSec != TargetNewCWORK2sleepMiliSec)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK2sleepMiliSec, TargetNewCWORK2sleepMiliSec);
                    TargetCWORK2sleepMiliSec = TargetNewCWORK2sleepMiliSec;
                }
                if (TargetCWORK2loopCnt != TargetNewCWORK2loopCnt)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK2loopCnt, TargetNewCWORK2loopCnt);
                    TargetCWORK2loopCnt = TargetNewCWORK2loopCnt;
                }

                if (TargetCWORK3sleepMiliSec != TargetNewCWORK3sleepMiliSec)
                {
                    Console.WriteLine("{0}, {1}", TargetCWORK3sleepMiliSec, TargetNewCWORK3sleepMiliSec);
                    TargetCWORK3sleepMiliSec = TargetNewCWORK3sleepMiliSec;
                }
                Thread.Sleep(1000);
            }
        }

        
        private void ChangeDBConfigLoop(int modifyConfigValue, int currentConfigValue, string methodName)
        {
            InputEventArgs args;
            for (var i = 0; i < Math.Abs(currentConfigValue - modifyConfigValue); i++)
            {
                args = new InputEventArgs();
                args.methodName = methodName;
                args.command = currentConfigValue - modifyConfigValue < 0 ? "START" : "STOP";
                OnChangeDBConfig(args);
            }
        }

        protected virtual void OnChangeDBConfig(InputEventArgs e)
        {
            EventHandler<InputEventArgs> handler = ChangeDBConfigEvent;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        public event EventHandler<InputEventArgs> ChangeDBConfigEvent;

    } // CConfigEnd


}
