﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Collections;
using System.Security.Cryptography;
using System.Data.SqlClient;
using System.Data;
using System.Runtime.InteropServices;
using minsouk.WorkGenerator;

namespace minsouk.WorkGenerator
{
    class CDatabase
    {
        string ConnectionString = string.Empty;

        public CDatabase(string ConnectionString)
        {
            this.ConnectionString = ConnectionString;
        }

        public List<TConfig> uspGetTConfig(int configIdx)
        {
            List<TConfig> TConfigs = new List<TConfig>();
            using (SqlConnection conn = new SqlConnection(this.ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = conn.CreateCommand())
                {
                    cmd.CommandText = "dbo.uspGetTConfig";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Clear();
                    cmd.Parameters.Add("@configIdx", SqlDbType.Int).Value = configIdx;
                    SqlDataReader reader = cmd.ExecuteReader();
                    while (reader.Read())
                    {
                        TConfig tConfig = new TConfig();
                        tConfig.configIdx = reader.IsDBNull(reader.GetOrdinal("configIdx")) ? 0 : reader.GetInt32(reader.GetOrdinal("configIdx"));
                        tConfig.workType = reader.IsDBNull(reader.GetOrdinal("workType")) ? "" : reader.GetString(reader.GetOrdinal("workType"));
                        tConfig.cKey = reader.IsDBNull(reader.GetOrdinal("cKey")) ? "" : reader.GetString(reader.GetOrdinal("cKey"));
                        tConfig.cValue = reader.IsDBNull(reader.GetOrdinal("cValue")) ? "" : reader.GetString(reader.GetOrdinal("cValue"));
                        TConfigs.Add(tConfig);
                    }
                    reader.Close();
                }
                conn.Close();
            }
            return TConfigs;
        }
    }

    class CWorkloadDatabase
    {
        string ConnectionString = string.Empty;

        public CWorkloadDatabase(string ConnectionString)
        {
            this.ConnectionString = ConnectionString;
        }

        public string uspWorkLoadTypeCPU(int variable1)
        {
            string dbOutput = string.Empty;
            List<TConfig> TConfigs = new List<TConfig>();
            using (SqlConnection conn = new SqlConnection(this.ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = conn.CreateCommand())
                {
                    cmd.CommandText = "dbo.uspWorkLoadTypeCPU";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Clear();
                    cmd.Parameters.Add("@variable1", SqlDbType.Int).Value = variable1;
                    cmd.Parameters.Add("@dbOutput", SqlDbType.VarChar, 100).Direction = ParameterDirection.Output;
                    cmd.CommandTimeout = 0;
                    cmd.ExecuteNonQuery();
                    dbOutput = cmd.Parameters["@dbOutput"].Value.ToString();
                    conn.Close();

                }
                conn.Close();
            }
            return dbOutput;
        }


        public string uspWorkLoadTypeMemory(int variable1)
        {
            string dbOutput = string.Empty;
            List<TConfig> TConfigs = new List<TConfig>();
            using (SqlConnection conn = new SqlConnection(this.ConnectionString))
            {
                conn.Open();
                using (SqlCommand cmd = conn.CreateCommand())
                {
                    cmd.CommandText = "dbo.uspWorkLoadTypeMemory";
                    cmd.CommandType = CommandType.StoredProcedure;
                    cmd.Parameters.Clear();
                    cmd.Parameters.Add("@variable1", SqlDbType.Int).Value = variable1;
                    cmd.Parameters.Add("@dbOutput", SqlDbType.VarChar, 100).Direction = ParameterDirection.Output;
                    cmd.CommandTimeout = 0;
                    cmd.ExecuteNonQuery();
                    dbOutput = cmd.Parameters["@dbOutput"].Value.ToString();
                    conn.Close();

                }
                conn.Close();
            }
            return dbOutput;
        }
    }
    public class TConfig
    {
        public int configIdx { get; set; }
        public string workType { get; set; }
        public string cKey { get; set; }
        public string cValue { get; set; }
    }

    public class WorkTypeCnt
    {
        public string workType;
        public string cValue;
    }
}
