﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Collections;
using System.Security.Cryptography;
using System.Data.SqlClient;
using System.Data;
using System.Runtime.InteropServices;
using minsouk.WorkGenerator;

namespace minsouk.WorkGenerator
{
    abstract class CWork
    {
        protected volatile bool isStop = false;
        public int instanceId { get; set; }
        public CConfig config = null;
        
        public CWork(CThreadManager cThreadManager)
        {
            this.isStop = false;
            WorkStatusChangeEvent += cThreadManager.OnEventAction;
            config = cThreadManager.config;
        }

        public void StartWork()
        {
            this.isStop = false;
            Work();
        }

        public void StopWork()
        {
            this.isStop = true;
        }

        public abstract void Work();

        protected virtual void OnWorkStatusChange(InputEventArgs e)
        {
            EventHandler<InputEventArgs> handler = WorkStatusChangeEvent;
            if (handler != null)
            {
                handler(this, e);
            }
        }

        public event EventHandler<InputEventArgs> WorkStatusChangeEvent;
    }
}