﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Threading;
using System.IO;
using System.Diagnostics;
using System.Reflection;
using System.Collections;
using System.Security.Cryptography;
using System.Data.SqlClient;
using System.Data;
using System.Runtime.InteropServices;
using minsouk.WorkGenerator;

namespace minsouk.WorkGenerator
{

    class Program
    {
        static void Main(string[] args)
        {
            // Configuration
            CConfig config = CConfig.Config; // singleton
            config.LoadConfiguration(args);

            // thread manager generate
            CThreadManager cThreadManager = new CThreadManager(config);
            Thread workStatusShowThread = new Thread(() => cThreadManager.ShowWorkThread());
            workStatusShowThread.Start();

            // default workload start and key input thread 
            CKeyInput cCkeyInput = new CKeyInput(cThreadManager);
            Thread doDefaultWorkThread = new Thread(cCkeyInput.DoDefaultWork);
            Thread commandPromptReadKeyThread = new Thread(cCkeyInput.CommandPromptReadKey);
            doDefaultWorkThread.Start();
            commandPromptReadKeyThread.Start();

            // database config value detect
            Thread changeDBConfigCheckThread = new Thread(() => config.ChangeDBConfigCheck(config.configIdx, cThreadManager));
            changeDBConfigCheckThread.Start();
        }
    }
}
